summaryrefslogtreecommitdiffstats
path: root/Makefile
diff options
context:
space:
mode:
authorManos Pitsidianakis <el13635@mail.ntua.gr>2020-01-31 03:45:55 +0200
committerManos Pitsidianakis <el13635@mail.ntua.gr>2020-02-04 02:58:21 +0200
commitbc98a0ef486d8a5329205117f86dbd3155aa0e1a (patch)
tree24b5f5e77387037c76a513f70551b914106f20ef /Makefile
parentbb80de91aee1fd2953ba142693076188e64223a5 (diff)
Makefile: make Makefile portable
Tested with - GNU Make 4.2.1 - bmake 20160220-2+b1
Diffstat (limited to 'Makefile')
-rw-r--r--Makefile118
1 files changed, 59 insertions, 59 deletions
diff --git a/Makefile b/Makefile
index 2bf64d6e..66e628c7 100644
--- a/Makefile
+++ b/Makefile
@@ -28,61 +28,63 @@ CARGO_BIN ?= cargo
# Installation parameters
MANPAGES ?= meli.1 meli.conf.5 meli-themes.5
-ifdef MELI_FEATURES
- FEATURES ?= --features="$(MELI_FEATURES)"
-else
- FEATURES ?=
-endif
-
-ifndef MANPATH
- MANPATH = `manpath`
-endif
+FEATURES ?= --features="$(MELI_FEATURES)"
+
+MANPATHS := `manpath 2> /dev/null`
VERSION ?= `sed -n "s/^version\s*=\s*\"\(.*\)\"/\1/p" Cargo.toml`
# Output parameters
-BOLD ?= tput bold
-UNDERLINE ?= tput smul
-ANSI_RESET ?= tput sgr0
-ifdef NO_COLOR
- RED ?=
- GREEN ?=
- CARGO_COLOR ?= --color=never
-else
- RED ?= tput setaf 1
- GREEN ?= tput setaf 2
-endif
+BOLD ?= `tput bold`
+UNDERLINE ?= `tput smul`
+ANSI_RESET ?= `tput sgr0`
+CARGO_COLOR ?= `[ -z $${NO_COLOR+x} ] && echo "" || echo "--color=never "`
+RED ?= `[ -z $${NO_COLOR+x} ] && tput setaf 1 || echo ""`
+GREEN ?= `[ -z $${NO_COLOR+x} ] && tput setaf 2 || echo ""`
.POSIX:
.SUFFIXES:
help:
- @echo "For a quick start, build and install locally:\n `${BOLD}``${GREEN}`PREFIX=~/.local make install`${ANSI_RESET}`\n"
+ @echo "For a quick start, build and install locally:\n ${BOLD}${GREEN}PREFIX=~/.local make install${ANSI_RESET}\n"
@echo "Available subcommands:"
- @echo " - `${BOLD}`install`${ANSI_RESET}` (installs binary and documentation)"
- @echo " - `${BOLD}`uninstall`${ANSI_RESET}`"
+ @echo " - ${BOLD}install${ANSI_RESET} (installs binary and documentation)"
+ @echo " - ${BOLD}uninstall${ANSI_RESET}"
@echo "Secondary subcommands:"
- @echo " - `${BOLD}`clean`${ANSI_RESET}` (cleans build artifacts)"
- @echo " - `${BOLD}`check-deps`${ANSI_RESET}` (checks dependencies)"
- @echo " - `${BOLD}`install-bin`${ANSI_RESET}` (installs binary to BINDIR)"
- @echo " - `${BOLD}`install-doc`${ANSI_RESET}` (installs manpages to MANDIR)"
- @echo " - `${BOLD}`help`${ANSI_RESET}` (prints this information)"
-
- @echo " - `${BOLD}`dist`${ANSI_RESET}` (creates release tarball named meli-${VERSION}.tar.gz)"
- @echo " - `${BOLD}`deb-dist`${ANSI_RESET}` (builds debian package)"
- @echo " - `${BOLD}`distclean`${ANSI_RESET}` (cleans distribution build artifacts)"
+ @echo " - ${BOLD}clean${ANSI_RESET} (cleans build artifacts)"
+ @echo " - ${BOLD}check-deps${ANSI_RESET} (checks dependencies)"
+ @echo " - ${BOLD}install-bin${ANSI_RESET} (installs binary to BINDIR)"
+ @echo " - ${BOLD}install-doc${ANSI_RESET} (installs manpages to MANDIR)"
+ @echo " - ${BOLD}help${ANSI_RESET} (prints this information)"
+
+ @echo " - ${BOLD}dist${ANSI_RESET} (creates release tarball named meli-"${VERSION}".tar.gz)"
+ @echo " - ${BOLD}deb-dist${ANSI_RESET} (builds debian package)"
+ @echo " - ${BOLD}distclean${ANSI_RESET} (cleans distribution build artifacts)"
@echo "\nENVIRONMENT variables of interest:"
- @echo "* PREFIX = ${PREFIX}"
- @echo "* MELI_FEATURES = ${MELI_FEATURES}"
- @echo "* BINDIR = ${BINDIR}"
- @echo "* MANDIR = ${MANDIR}"
+ @echo "* PREFIX = ${UNDERLINE}${PREFIX}${ANSI_RESET}"
+ @echo -n "* MELI_FEATURES = ${UNDERLINE}"
+ @[ -z $${MELI_FEATURES+x} ] && echo -n "unset" || echo -n ${MELI_FEATURES}
+ @echo ${ANSI_RESET}
+ @echo "* BINDIR = ${UNDERLINE}${BINDIR}${ANSI_RESET}"
+ @echo "* MANDIR = ${UNDERLINE}${MANDIR}${ANSI_RESET}"
+ @echo -n "* MANPATH = ${UNDERLINE}"
+ @[ $${MANPATH+x} ] && echo -n $${MANPATH} || echo -n "unset"
+ @echo ${ANSI_RESET}
+ @echo "* output of manpath(1) = ${UNDERLINE}${MANPATHS}${ANSI_RESET}"
+ @echo -n "* NO_MAN ${UNDERLINE}"
+ @[ $${NO_MAN+x} ] && echo -n "set" || echo -n "unset"
+ @echo ${ANSI_RESET}
+ @echo -n "* NO_COLOR ${UNDERLINE}"
+ @[ $${NO_COLOR+x} ] && echo -n "set" || echo -n "unset"
+ @echo ${ANSI_RESET}
+ @#@echo "* CARGO_COLOR = ${CARGO_COLOR}"
meli: check-deps
- ${CARGO_BIN} build ${CARGO_COLOR}--target-dir="${CARGO_TARGET_DIR}" $(FEATURES)--release
+ @${CARGO_BIN} build ${CARGO_COLOR}--target-dir="${CARGO_TARGET_DIR}" ${FEATURES} --release
.PHONY: check-deps
check-deps:
- @if ! echo ${MIN_RUSTC}\\n`${CARGO_BIN} --version | cut -d ' ' -f 2` | sort -CV; then echo "rust version >= `${RED}`${MIN_RUSTC}`${ANSI_RESET}` required, found: `which ${CARGO_BIN}` `${CARGO_BIN} --version | cut -d ' ' -f 2`" \
- "\nYour options:\n - Set CARGO_BIN to a supported version\n - Install a supported version from your distribution's package manager\n - Install a supported version from `${UNDERLINE}`https://rustup.rs/`${ANSI_RESET}`" ; exit 1; fi
+ @(if ! echo ${MIN_RUSTC}\\n`${CARGO_BIN} --version | cut -d ' ' -f 2` | sort -CV; then echo "rust version >= ${RED}${MIN_RUSTC}${ANSI_RESET} required, found: `which ${CARGO_BIN}` `${CARGO_BIN} --version | cut -d ' ' -f 2`" \
+ "\nYour options:\n - Set CARGO_BIN to a supported version\n - Install a supported version from your distribution's package manager\n - Install a supported version from ${UNDERLINE}https://rustup.rs/${ANSI_RESET}" ; exit 1; fi)
.PHONY: clean
@@ -102,31 +104,29 @@ uninstall:
.PHONY: install-doc
install-doc:
-ifndef NO_MAN
- @mkdir -p $(DESTDIR)${MANDIR}/man1
- @mkdir -p $(DESTDIR)${MANDIR}/man5
- @echo " - `${BOLD}`Installing manpages to `${ANSI_RESET}`${DESTDIR}${MANDIR}:"
- @for MANPAGE in ${MANPAGES}; do \
+ @(if [ -z $${NO_MAN+x} ]; then \
+ mkdir -p $(DESTDIR)${MANDIR}/man1 ; \
+ mkdir -p $(DESTDIR)${MANDIR}/man5 ; \
+ echo " - ${BOLD}Installing manpages to ${ANSI_RESET}${DESTDIR}${MANDIR}:" ; \
+ for MANPAGE in ${MANPAGES}; do \
SECTION=`echo $${MANPAGE} | rev | cut -d "." -f 1`; \
MANPAGEPATH=${DESTDIR}${MANDIR}/man$${SECTION}/$${MANPAGE}.gz; \
- echo " * installing $${MANPAGE} → `${GREEN}`$${MANPAGEPATH}`${ANSI_RESET}`"; \
+ echo " * installing $${MANPAGE} → ${GREEN}$${MANPAGEPATH}${ANSI_RESET}"; \
gzip < $${MANPAGE} > $${MANPAGEPATH} \
- ; done
- @case ":${MANPATH}:" in \
+ ; done ; \
+ (case ":${MANPATHS}:" in \
*:${DESTDIR}${MANDIR}:*) echo -n "";; \
- *) echo "\n`${RED}``${BOLD}`WARNING`${ANSI_RESET}`: `${UNDERLINE}`Path ${DESTDIR}${MANDIR} is not contained in your MANPATH variable or the output of \`manpath\` command.`${ANSI_RESET}` \`man\` might fail finding the installed manpages. Consider adding it if necessary.\nMANPATH variable / output of \`manpath\`: ${MANPATH}" ;; \
- esac
-else
- @echo "NO_MAN is defined, so no documentation is going to be installed."
-endif
+ *) echo "\n${RED}${BOLD}WARNING${ANSI_RESET}: ${UNDERLINE}Path ${DESTDIR}${MANDIR} is not contained in your MANPATH variable or the output of \`manpath\` command.${ANSI_RESET} \`man\` might fail finding the installed manpages. Consider adding it if necessary.\nMANPATH variable / output of \`manpath\`: ${MANPATHS}" ;; \
+ esac) ; \
+ else echo "NO_MAN is defined, so no documentation is going to be installed." ; fi)
.PHONY: install-bin
install-bin: meli
@mkdir -p $(DESTDIR)${BINDIR}
- @echo " - `${BOLD}`Installing binary to `${ANSI_RESET}``${GREEN}`${DESTDIR}${BINDIR}/meli`${ANSI_RESET}`"
+ @echo " - ${BOLD}Installing binary to ${ANSI_RESET}${GREEN}${DESTDIR}${BINDIR}/meli${ANSI_RESET}"
@case ":${PATH}:" in \
*:${DESTDIR}${BINDIR}:*) echo -n "";; \
- *) echo "\n`${RED}``${BOLD}`WARNING`${ANSI_RESET}`: `${UNDERLINE}`Path ${DESTDIR}${BINDIR} is not contained in your PATH variable.`${ANSI_RESET}` Consider adding it if necessary.\nPATH variable: ${PATH}";; \
+ *) echo "\n${RED}${BOLD}WARNING${ANSI_RESET}: ${UNDERLINE}Path ${DESTDIR}${BINDIR} is not contained in your PATH variable.${ANSI_RESET} Consider adding it if necessary.\nPATH variable: ${PATH}";; \
esac
@install -D ./${CARGO_TARGET_DIR}/release/meli $(DESTDIR)${BINDIR}/meli
@@ -134,10 +134,10 @@ install-bin: meli
.PHONY: install
.NOTPARALLEL: yes
install: meli install-bin install-doc
-ifndef NO_MAN
- @echo "\n You're ready to go. You might want to read the \"STARTING WITH meli\" section in the manpage (\`man meli\`)"
-endif
- @echo " - Report bugs in the mailing list or git issue tracker `${UNDERLINE}`https://git.meli.delivery`${ANSI_RESET}`"
+ @(if [ -z $${NO_MAN+x} ]; then \
+ echo "\n You're ready to go. You might want to read the \"STARTING WITH meli\" section in the manpage (\`man meli\`)" ;\
+ fi)
+ @echo " - Report bugs in the mailing list or git issue tracker ${UNDERLINE}https://git.meli.delivery${ANSI_RESET}"
@echo " - If you have a specific feature or workflow you want to use, you can post in the mailing list or git issue tracker."
.PHONY: dist
@@ -148,4 +148,4 @@ dist:
.PHONY: deb-dist
deb-dist:
@dpkg-buildpackage -b -rfakeroot -us -uc
- @echo `${BOLD}``${GREEN}`Generated`${ANSI_RESET}` ../meli_${VERSION}-1_amd64.deb
+ @echo ${BOLD}${GREEN}Generated${ANSI_RESET} ../meli_${VERSION}-1_amd64.deb